/***************************************************************************
              f4lmview.cpp  -  description
                 -------------------
    begin                : Sat Jun  7 02:29:46 EEST 2003
    copyright            : (C) 2003 by zkan pakdil
    email                : ozkanpakdil@users.sourceforge.net
 ***************************************************************************/


/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// include files for Qt
#include <qprinter.h>
#include <qpainter.h>
#include <qslider.h>
#include <qpainter.h>
#include <qimage.h>
#include <qbuttongroup.h>
#include <qsizepolicy.h>

// application specific includes
#include "f4lmview.h"
#include "f4lmdoc.h"
#include "f4lm.h"
#include "main_doc_ico.xpm"
#include "clayer.h"
#include "cbase.h"
#include "ccanvas.h"
#include "tools.h"
#include "canvasItem.h"

F4lmView::F4lmView (F4lmDoc * pDoc, QWidget * parent, const char *name, int wflags)
    :QWidget (parent, name, wflags) {
    setName ("F4lmView");
    dad = (F4lmApp *) parentWidget ()->parent ()->parent ();
    doc = pDoc;
    resize (700, 600);
    setIcon (QPixmap ((const char **) main_doc_ico_xpm));
    layerNum = 1;
    defSceneHeight = 440;
    defSceneWidth = 550;
    defSceneRect = QRect (600, 600, defSceneWidth, defSceneHeight);
    QVBoxLayout * topLayout = new QVBoxLayout (this);
    //CBase *base=new CBase(this);
    CLayer * layer1 = new CLayer (this, "layer 1");
    CCanvas * main = new CCanvas (this, "mc");
    CSceneRect * defrect = new CSceneRect (defSceneRect, main);
    defrect->setBrush (QColor (255, 255, 255));
    defrect->setZ (-1);
    defrect->show ();
    main->resize (defSceneWidth + defSceneWidth + 600,defSceneHeight + defSceneHeight + 600);
    main->setBackgroundColor (QColor (208, 208, 208));
    //layer1->pCanvasList->append(main);
    doc->pLayerList->append (layer1);
    canvasViewer = new canview (main, this, "Canvas viewer");
    //base->addChild(canvasViewer);
    canvasViewer->scrollBy (550, 550);
    topLayout->addWidget (canvasViewer);
    //this means nothing will be drawed in canvasview
    defObjID = 0;
    //this means first color for drawing is black
    defObjCOLOR = QColor (0, 0, 0);
    //qDebug(QString::number(defObjCOLOR.red()));

    /*boundaries=new QValueVector<canvasBoundaries>();
       canvasBoundaries tcanvb;
       tcanvb.canvasLimitsForTable[0][0]=layerNum;
       tcanvb.canvasLimitsForTable[0][1]=0;
       tcanvb.canvasLimitsForTable[0][2]=0;
       boundaries->push_back(tcanvb); */

}

F4lmView::~F4lmView () {
}

F4lmDoc * F4lmView::getDocument () const {
    return doc;
}

void F4lmView::update (F4lmView * pSender) {
    if (pSender != this)
    repaint ();
}

void F4lmView::print (QPrinter * pPrinter) {
    if (pPrinter->setup (this)) {
    QPainter p;
    p.begin (pPrinter);
        ///////////////////////////////
        // TODO: add your printing code here
        ///////////////////////////////
    p.end ();
    }
}

void F4lmView::closeEvent (QCloseEvent *) {
    // LEAVE THIS EMPTY: THE EVENT FILTER IN THE F4lmApp CLASS TAKES CARE FOR CLOSING
    // QWidget closeEvent must be prevented.
}

void F4lmView::slotNewLayer () {
    CLayer * layer = new CLayer (this, "layer" + QString::number (layerNum));
    CCanvas * main = new CCanvas (this, "m");
    QCanvasRectangle * defrect = new QCanvasRectangle (defSceneRect, main);
    defrect->setBrush (QColor (255, 255, 255));
    defrect->setZ (-1);
    defrect->show ();
    main->resize (defSceneWidth + defSceneWidth + 600,defSceneHeight + defSceneHeight + 600);
    main->setBackgroundColor (QColor (208, 208, 208));
    //    layer->pCanvasList->append(main);
    doc->pLayerList->append (layer);
}

void F4lmView::slotInsertFrame (int row, int col) {
    if (CLayer * l = doc->pLayerList->at (row)) {
    for (int i = l->pCanvasList->count (); i < col; i++) {
        CCanvas * main = new CCanvas (this, "mc " + QString::number (i));
        CSceneRect * defrect = new CSceneRect (defSceneRect, main);
        defrect->setBrush (QColor (255, 255, 255));
        defrect->setZ (-1);
        defrect->show ();
        main->resize (defSceneWidth + defSceneWidth + 600,defSceneHeight + defSceneHeight + 600);
        main->setBackgroundColor (QColor (208, 208, 208));
        l->pCanvasList->append (main);
    }
    } else
    qDebug ("orda layer yok");

}

void F4lmView::slotShowCanvas (int row, int col) {
    //qDebug("row:%d col:%d listNum:%d",row,col);
    CLayer * l;
    CCanvas *curCan = NULL;

    if (row < doc->pLayerList->count ())
    l = doc->pLayerList->at (row);

    if (col < l->pCanvasList->count () && l)
    curCan = l->pCanvasList->at (col);

    if (curCan && curCan != canvasViewer->canvas ())
    canvasViewer->setCanvas (curCan);

}

void F4lmView::mouseMoveEvent (QMouseEvent * e) {
    QWidget::mouseMoveEvent (e);
}


